import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
public class Bird extends Actor {
    
    /** The gravity to the ground. */
    public static final int GRAVITY = 1;
    
    /** The horizontal speed that the bird flies (the pipes move backwards). */
    public static final int SPEED = 10;
    
    /** The vertical speed when the bird flaps. */
    public static final int FLAP_SPEED = -10;
    
    /** The current virtical speed. */
    private int speed = 0;
    
    /** The score. */
    private int score = 0;
    
    /**
     * Creates a new bird.
     * 
     */
    public Bird() {
        speed = 0;
        score = 0;
    }
    
    /**
     * Things to do for each turn.
     * 
     */
    public void act() {

        checkFlap();

        move();

        if (checkHit()) {
            Level1 level1 = (Level1) getWorld();
            level1.gameOver(score);
        } else {

            checkScore();
        }
    }
    
    /**
     * Checks if the bird flaps.
     * 
     */
    private void checkFlap() {
        if (Greenfoot.mouseClicked(null)) {
            speed = FLAP_SPEED;
        }
    }

    private void move() {
        speed = speed + GRAVITY;
        setLocation(getX(), getY() + speed);
    }
    
    private boolean checkHit() {
        if (isTouching(Pipe.class)) {
            return true;
        }
        if (getY() == getWorld().getHeight() - 1) {
            return true;
        }
        return false;
    }
    private void checkScore() {
        if (isTouching(ScoreLine.class)) {
            removeTouching(ScoreLine.class);
            score++;
            Level1 level1 = (Level1) getWorld();
            level1.setScore(score);
        }
    }
}